/*
 * Copyright 2014, 2015 Peter Hansen and İnanç Seylan.
 * 
 * This file is part of Grind.
 * 
 * Grind is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Grind is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Grind.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.unibremen.informatik.tdki.grind.omegaconstruction;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author hansen
 */
public class Omega {

    private Set<OmegaTuple> omegaTuples= new HashSet<>();
    
    public Omega() {
    }

    public Omega(Set<OmegaTuple> omegaTuples) {
        this.omegaTuples = omegaTuples;
    }
    
    public boolean addTuple(OmegaTuple e) {
        return omegaTuples.add(e);
    }

    @Override
    public String toString() {
        String result = "{\n";
        for (Iterator<OmegaTuple> it = omegaTuples.iterator(); it.hasNext();) {
            result += "  " + it.next().toString();
            if (it.hasNext()) {
                result += ",\n";
            }
        }
        result += "\n}";
        return result;
    }

    public Set<OmegaTuple> getOmegaTuples() {
        return omegaTuples;
    }
}
