/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.control.rewriters;

import com.google.common.collect.Sets;
import de.unibremen.informatik.tdki.grind.control.GammaAndOmegaCaller;
import de.unibremen.informatik.tdki.grind2.context.CQContext;
import de.unibremen.informatik.tdki.grind2.cq.CQ;
import de.unibremen.informatik.tdki.grind2.cq.AQ;
import de.unibremen.informatik.tdki.grind2.datalog.DatalogProgram;
import de.unibremen.informatik.tdki.grind2.datalog.DatalogRule;
import de.unibremen.informatik.tdki.grind2.datalog.components.DatalogAtom;
import de.unibremen.informatik.tdki.grind2.datalog.components.DatalogClassAtom;
import de.unibremen.informatik.tdki.grind2.datalog.components.DatalogQueryAtom;
import de.unibremen.informatik.tdki.grind2.datalog.components.DatalogVariable;
import java.util.Set;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.OWLAxiom;
import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLOntology;

/**
 *
 * @author hansen
 */
public class AQRewriter extends QueryRewriter {

    public AQRewriter(Set<OWLAxiom> axioms) {
        super(axioms);
    }

    @Override
    public int rewrite(CQ q0) throws Exception {

        AQ q = q0.asAQ();
        OWLClass conceptname = q.getConceptname();

        OWLOntology ont = OWLManager.createOWLOntologyManager().createOntology(this.getAxioms());
        GammaAndOmegaCaller caller = new GammaAndOmegaCaller(ont);

        int retval = caller.runSingleConceptname(conceptname);
        if (retval == 0) {
            DatalogProgram resultingProgram2 = caller.getResultingProgram();

            // First rule states: Q(?0)  <-  Bacillus(?0)
            DatalogAtom headAtom = new DatalogQueryAtom(Sets.newHashSet(new DatalogVariable(0)));
            DatalogAtom bodyAtom = new DatalogClassAtom(conceptname, new DatalogVariable(0));
            Set<DatalogAtom> bodyAtoms = Sets.newHashSet(bodyAtom);
            DatalogRule startRule = new DatalogRule(headAtom, bodyAtoms);
            resultingProgram2.getSetOfRules().add(startRule);

            this.resultingProgram = resultingProgram2;
        }
        return retval;
    }

}
