/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.cq;

import de.unibremen.informatik.tdki.grind2.cq.components.Atom;
import de.unibremen.informatik.tdki.grind2.cq.components.ClassAtom;
import de.unibremen.informatik.tdki.grind2.cq.components.RoleAtom;
import de.unibremen.informatik.tdki.grind2.cq.components.Variable;
import java.util.Set;
import org.semanticweb.owlapi.model.OWLClass;

/**
 *
 * @author hansen
 */
public class AQ extends CQ {

    OWLClass cls;

    public AQ(Set<Variable> avars, Set<Atom> setOfAtoms) throws CQException {
        super(avars, setOfAtoms);

        if (avars.size() != 1) {
            throw new CQException("[" + this.getClass().getSimpleName() + "] Tried to construct AQ with no or many avars!");
        }
        if (setOfAtoms.size() != 1) {
            throw new CQException("[" + this.getClass().getSimpleName() + "] Tried to construct AQ with too many atoms!");
        }
        Atom singleAtom = setOfAtoms.iterator().next();
        if (singleAtom instanceof RoleAtom) {
            throw new CQException("[" + this.getClass().getSimpleName() + "] Tried to construct AQ with role atom!");
        }
        ClassAtom cat = (ClassAtom) singleAtom;
        cls = cat.getCls();
    }

    public OWLClass getConceptname() {
        return this.cls;
    }
}
