/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.datalog.components;

import java.util.Objects;
import org.semanticweb.owlapi.model.OWLClass;

/**
 *
 * @author hansen
 */
public class DatalogClassAtom extends DatalogAtom {
    
    private final OWLClass concept;
    private final DatalogVariable x;

    public DatalogClassAtom(OWLClass concept, DatalogVariable x) {
        this.concept = concept;
        this.x = x;
    }

    public OWLClass getConcept() {
        return concept;
    }

    public DatalogVariable getX() {
        return x;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 67 * hash + Objects.hashCode(this.concept);
        hash = 67 * hash + Objects.hashCode(this.x);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DatalogClassAtom other = (DatalogClassAtom) obj;
        if (!Objects.equals(this.concept, other.concept)) {
            return false;
        }
        if (!Objects.equals(this.x, other.x)) {
            return false;
        }
        return true;
    }



    @Override
    public String toString() {
        return this.concept.toString() + '(' + x + ')';
    }
    
    
}
