/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.datalog.components;

import java.util.List;
import java.util.Objects;
import java.util.Set;

/**
 *
 * @author hansen
 */
public class DatalogQueryAtom extends DatalogAtom {

    private final Set<DatalogVariable> setOfVars;
    private final String headPredicate;

    public DatalogQueryAtom(Set<DatalogVariable> setOfVars) {
        this.setOfVars = setOfVars;
        this.headPredicate = "Q";
    }

    public DatalogQueryAtom(Set<DatalogVariable> setOfVars, String headPredicate) {
        this.setOfVars = setOfVars;
        this.headPredicate = headPredicate;
    }

    public String getHeadPredicate() {
        return headPredicate;
    }

    public Set<DatalogVariable> getSetOfVars() {
        return setOfVars;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 89 * hash + Objects.hashCode(this.setOfVars);
        hash = 89 * hash + Objects.hashCode(this.headPredicate);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DatalogQueryAtom other = (DatalogQueryAtom) obj;
        if (!Objects.equals(this.headPredicate, other.headPredicate)) {
            return false;
        }
        if (!Objects.equals(this.setOfVars, other.setOfVars)) {
            return false;
        }
        return true;
    }


    @Override
    public String toString() {
        String result = this.headPredicate + '(';
        for (DatalogVariable x : this.setOfVars) {
            result += x + ", ";
        }
        result = result.substring(0, result.length() - 2); // Delete last ", "
        result += ')';
        return result;
    }

}
