/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.datalog.components;

import java.util.Objects;
import org.semanticweb.owlapi.model.OWLObjectProperty;

/**
 *
 * @author hansen
 */
public class DatalogRoleAtom extends DatalogAtom {
    
    private final OWLObjectProperty role;
    private final DatalogVariable x;
    private final DatalogVariable y;

    public DatalogRoleAtom(OWLObjectProperty role, DatalogVariable x, DatalogVariable y) {
        this.role = role;
        this.x = x;
        this.y = y;
    }

    public OWLObjectProperty getRole() {
        return role;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 47 * hash + Objects.hashCode(this.role);
        hash = 47 * hash + Objects.hashCode(this.x);
        hash = 47 * hash + Objects.hashCode(this.y);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DatalogRoleAtom other = (DatalogRoleAtom) obj;
        if (!Objects.equals(this.role, other.role)) {
            return false;
        }
        if (!Objects.equals(this.x, other.x)) {
            return false;
        }
        if (!Objects.equals(this.y, other.y)) {
            return false;
        }
        return true;
    }


    @Override
    public String toString() {
        return this.role.toString() + '(' + x + ", " + y + ')';
    }
    
    
    
}
