/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.runnables;

import de.unibremen.informatik.tdki.grind.control.GammaAndOmegaCaller;
import de.unibremen.informatik.tdki.grind2.context.CQContext;
import java.io.FileNotFoundException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;

/**
 *
 * @author hansen
 */
public class RunOccurringCNs {

    static boolean verbose = false;

    public static void main(String[] args) throws OWLOntologyCreationException, FileNotFoundException, Exception {

        CQContext.getINSTANCE().setVerbose(verbose);
        
//        String[] ontSources = new String[]{
//            "./ontologies/grind1-test-ontologies/envo.owl",
//            "./ontologies/grind1-test-ontologies/so.owl",
//            "./ontologies/grind1-test-ontologies/not-galen.owl"};
        Date dNow = new Date();
        SimpleDateFormat ft = new SimpleDateFormat("yyyyMMdd-HHmmss");
        System.out.println("Current Date: " + ft.format(dNow));
        String date = ft.format(dNow);
        String s;
        GammaAndOmegaCaller caller;
        List<List<String>> occurringConceptsPerQuery;
        List<String> stringList;
        long t0;
        int i;

        // ---------- ENVO --------------
        s = "./ontologies/grind1-test-ontologies/envo.owl";
        t0 = System.currentTimeMillis();
        occurringConceptsPerQuery = new ArrayList<>();

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00002272");
        stringList.add("owlENVO_00000358");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000856");
        stringList.add("owlENVO_00003885");
        stringList.add("owlENVO_00000247");
        stringList.add("owlENVO_00000086");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000081");
        stringList.add("owlENVO_00000080");
        stringList.add("owlENVO_00000133");
        stringList.add("owlENVO_00000247");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00002271");
        stringList.add("owlENVO_00002222");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000022");
        stringList.add("owlENVO_00000025");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000298");
        stringList.add("owlENVO_00002006");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00002173");
        stringList.add("owlENVO_00000569");
        stringList.add("owlENVO_00000097");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000080");
        stringList.add("owlENVO_00000305");
        stringList.add("owlENVO_00000098");
        stringList.add("owlENVO_00000081");
        stringList.add("owlENVO_00000015");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000247");
        stringList.add("owlENVO_00000353");
        stringList.add("owlENVO_00000246");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlENVO_00000335");
        stringList.add("owlENVO_00000175");
        stringList.add("owlENVO_00000009");
        occurringConceptsPerQuery.add(stringList);

        i = 1;
                caller = new GammaAndOmegaCaller(s);
        for (List<String> queryList : occurringConceptsPerQuery) {
            long t1 = System.currentTimeMillis();
            System.out.println("Working on query " + i);
            for (String concept : queryList) {
                long t = System.currentTimeMillis();
                System.out.println("Working on: " + concept);
                caller.runSingleConceptname(concept);
                System.out.println("Time spent on concept: " + (System.currentTimeMillis() - t) + " ms.");
            }
            System.out.println("### Time spent on query " + i + ": " + (System.currentTimeMillis() - t1) + " ms.");
            i++;
        }
        System.out.println("### Total time spent on ENVO: " + (System.currentTimeMillis() - t0) + " ms.");

        // ---------- FBbi --------------
        s = "./ontologies/grind1-test-ontologies/fbbi.owl";
        t0 = System.currentTimeMillis();
        occurringConceptsPerQuery = new ArrayList<>();

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000241");
        stringList.add("FBbi_00000399");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000241");
        stringList.add("FBbi_00000033");
        stringList.add("FBbi_00000079");
        stringList.add("FBbi_00000084");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000249");
        stringList.add("FBbi_00000368");
        stringList.add("FBbi_00000025");
        stringList.add("FBbi_00000057");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000344");
        stringList.add("FBbi_00000027");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000395");
        stringList.add("FBbi_00000297");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000374");
        stringList.add("FBbi_00000352");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000343");
        stringList.add("FBbi_00000375");
        stringList.add("FBbi_00000003");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000016");
        stringList.add("FBbi_00000410");
        stringList.add("FBbi_00000264");
        stringList.add("FBbi_00000434");
        stringList.add("FBbi_00000402");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000227");
        stringList.add("FBbi_00000611");
        stringList.add("FBbi_00000253");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("FBbi_00000241");
        stringList.add("FBbi_00000393");
        stringList.add("FBbi_00000028");
        occurringConceptsPerQuery.add(stringList);

        i = 1;
                caller = new GammaAndOmegaCaller(s);
        for (List<String> queryList : occurringConceptsPerQuery) {
            long t1 = System.currentTimeMillis();
            System.out.println("Working on query " + i);
            for (String concept : queryList) {
                long t = System.currentTimeMillis();
                System.out.println("Working on: " + concept);
                caller.runSingleConceptname(concept);
                System.out.println("Time spent on concept: " + (System.currentTimeMillis() - t) + " ms.");
            }
            System.out.println("### Time spent on query " + i + ": " + (System.currentTimeMillis() - t1) + " ms.");
            i++;
        }
        System.out.println("### Total time spent on FBbi: " + (System.currentTimeMillis() - t0) + " ms.");

        // ---------- MOHSE --------------
        s = "./ontologies/grind1-test-ontologies/mohse.owl";
        t0 = System.currentTimeMillis();
        occurringConceptsPerQuery = new ArrayList<>();

        stringList = new ArrayList<>();
        stringList.add("Organism");
        stringList.add("Endocarditis");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("CardiacSurgery");
        stringList.add("Organism");
        stringList.add("Tissue");
        stringList.add("InternalOrgan");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Triglyceride");
        stringList.add("Alcohol");
        stringList.add("InvestigationAct");
        stringList.add("CareAct");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Aminoglycoside");
        stringList.add("Giardia");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Duct");
        stringList.add("InternalOrgan");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("PathologyConstruct");
        stringList.add("VoluntaryMovement");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Protein");
        stringList.add("InternalOrgan");
        stringList.add("Tetracycline");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Sulphonamide");
        stringList.add("NAMEDEnzyme");
        stringList.add("TeichoicAcid");
        stringList.add("Tumour");
        stringList.add("Liver");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("ArterialDisease");
        stringList.add("Bordatella");
        stringList.add("Anonymous-294");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("InvestigationAct");
        stringList.add("Anonymous-294");
        stringList.add("Brain");
        occurringConceptsPerQuery.add(stringList);

        i = 1;
                caller = new GammaAndOmegaCaller(s);
        for (List<String> queryList : occurringConceptsPerQuery) {
            long t1 = System.currentTimeMillis();
            System.out.println("Working on query " + i);
            for (String concept : queryList) {
                long t = System.currentTimeMillis();
                System.out.println("Working on: " + concept);
                caller.runSingleConceptname(concept);
                System.out.println("Time spent on concept: " + (System.currentTimeMillis() - t) + " ms.");
            }
            System.out.println("### Time spent on query " + i + ": " + (System.currentTimeMillis() - t1) + " ms.");
            i++;
        }
        System.out.println("### Total time spent on MOHSE: " + (System.currentTimeMillis() - t0) + " ms.");

        // ---------- not-galen --------------
        s = "./ontologies/grind1-test-ontologies/not-galen.owl";
        t0 = System.currentTimeMillis();
        occurringConceptsPerQuery = new ArrayList<>();

        stringList = new ArrayList<>();
        stringList.add("Patient");
        stringList.add("Endocarditis");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Surgery");
        stringList.add("Doctor");
        stringList.add("Tissue");
        stringList.add("InternalOrgan");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Triglyceride");
        stringList.add("Alcohol");
        stringList.add("InvestigationAct");
        stringList.add("CareAct");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Aminoglycoside");
        stringList.add("Giardia");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Duct");
        stringList.add("InternalOrgan");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("PathologyConstruct");
        stringList.add("VoluntaryMovement");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Protein");
        stringList.add("InternalOrgan");
        stringList.add("Tetracycline");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("Sulphonamide");
        stringList.add("NAMEDEnzyme");
        stringList.add("TeichoicAcid");
        stringList.add("TumorMarkerRole");
        stringList.add("Liver");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("DiseaseState");
        stringList.add("Bordatella");
        stringList.add("NonNormalCondition");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("BodyStructure");
        stringList.add("IntrinsicallyNormalBodyStructure");
        stringList.add("Brain");
        occurringConceptsPerQuery.add(stringList);

        i = 1;
                caller = new GammaAndOmegaCaller(s);
        for (List<String> queryList : occurringConceptsPerQuery) {
            long t1 = System.currentTimeMillis();
            System.out.println("Working on query " + i);
            for (String concept : queryList) {
                long t = System.currentTimeMillis();
                System.out.println("Working on: " + concept);
                caller.runSingleConceptname(concept);
                System.out.println("Time spent on concept: " + (System.currentTimeMillis() - t) + " ms.");
            }
            System.out.println("### Time spent on query " + i + ": " + (System.currentTimeMillis() - t1) + " ms.");
            i++;
        }
        System.out.println("### Total time spent on not-galen: " + (System.currentTimeMillis() - t0) + " ms.");

        // ---------- SO --------------
        s = "./ontologies/grind1-test-ontologies/so.owl";
        t0 = System.currentTimeMillis();
        occurringConceptsPerQuery = new ArrayList<>();

        stringList = new ArrayList<>();
        stringList.add("owlSO_0000105");
        stringList.add("owlSO_0000823");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0005852");
        stringList.add("owlSO_0000088");
        stringList.add("owlSO_0000094");
        stringList.add("owlSO_0001810");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0000099");
        stringList.add("owlSO_0005851");
        stringList.add("owlSO_0000307");
        stringList.add("owlSO_0001219");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001837");
        stringList.add("owlSO_0001045");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001421");
        stringList.add("owlSO_0000820");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0000288");
        stringList.add("owlSO_0000129");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001414");
        stringList.add("owlSO_0001421");
        stringList.add("owlSO_0001026");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001105");
        stringList.add("owlSO_0001092");
        stringList.add("owlSO_0001018");
        stringList.add("owlSO_0000104");
        stringList.add("owlSO_0001431");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001411");
        stringList.add("owlSO_0000316");
        stringList.add("owlSO_0000104");
        occurringConceptsPerQuery.add(stringList);

        stringList = new ArrayList<>();
        stringList.add("owlSO_0001411");
        stringList.add("owlSO_0001435");
        stringList.add("owlSO_0000104");
        occurringConceptsPerQuery.add(stringList);

        i = 1;
                caller = new GammaAndOmegaCaller(s);
        for (List<String> queryList : occurringConceptsPerQuery) {
            long t1 = System.currentTimeMillis();
            System.out.println("Working on query " + i);
            for (String concept : queryList) {
                long t = System.currentTimeMillis();
                System.out.println("Working on: " + concept);
                caller.runSingleConceptname(concept);
                System.out.println("Time spent on concept: " + (System.currentTimeMillis() - t) + " ms.");
            }
            System.out.println("### Time spent on query " + i + ": " + (System.currentTimeMillis() - t1) + " ms.");
            i++;
        }
        System.out.println("### Total time spent on SO: " + (System.currentTimeMillis() - t0) + " ms.");
    }

}
