/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.runnables;

import de.unibremen.informatik.tdki.grind2.context.CQContext;
import de.unibremen.informatik.tdki.grind2.control.rewriters.QueryRewriter;
import de.unibremen.informatik.tdki.grind2.cq.AvarCQ;
import de.unibremen.informatik.tdki.grind2.cq.CQException;
import de.unibremen.informatik.tdki.grind2.cq.RootedCQ;
import de.unibremen.informatik.tdki.grind2.utilities.Signature;
import java.util.Set;
import org.semanticweb.owlapi.model.OWLAxiom;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;

/**
 *
 * @author hansen
 */
public class RunRandomCQs {

    private static final int NUMBER_OF_RUNS = 10;

    public static void main(String[] args) throws OWLOntologyCreationException, CQException, Exception {
        long t0 = System.currentTimeMillis();

        CQContext.load("./grind-test-ontologies/envo.owl");
        Set<OWLAxiom> axioms = CQContext.getINSTANCE().getOriginalOnt().getGCIsAsAxioms();
        
        runRandomAvar(axioms, "envo", 2);
        runRandomRCQ(axioms, "envo", 2);
//        runRandomRCQ("envo", 3);
//        runRandomRCQ("envo", 4);
//        runRandomRCQ("envo", 5);
//        RunHandcodedCQs.load("./grind-test-ontologies/fbbi.owl");
//        runRandomAvar("fbbi", 2);
//        runRandomRCQ("fbbi", 2);
//        runRandomRCQ("fbbi", 3);
//        runRandomRCQ("fbbi", 4);
//        runRandomRCQ("fbbi", 5);
//        RunHandcodedCQs.load("./grind-test-ontologies/mohse.owl");
//        runRandomAvar("mohse", 2);
//        runRandomRCQ("mohse", 2);
//        runRandomRCQ("mohse", 3);
//        runRandomRCQ("mohse", 4);
//        runRandomRCQ("mohse", 5);
//        RunHandcodedCQs.load("./grind-test-ontologies/not-galen.owl");
//        runRandomAvar("ng", 2);
//        runRandomRCQ("ng", 2);
//        runRandomRCQ("ng", 3);
//        runRandomRCQ("ng", 4);
//        runRandomRCQ("ng", 5);
//        RunHandcodedCQs.load("./grind-test-ontologies/so.owl");
//        runRandomAvar("so", 2);
//        runRandomRCQ("so", 2);
//        runRandomRCQ("so", 3);
//        runRandomRCQ("so", 4);
//        runRandomRCQ("so", 5);

    }

    public static int successfulRuns;
    public static int totalTime;

    public static void runRandomAvar(Set<OWLAxiom> axioms, String ontname, int noVars) throws OWLOntologyCreationException, CQException, Exception {

        Signature sigma = CQContext.getINSTANCE().getOriginalSignature();

        //System.out.println("Number of CIs in OrigOnt: " + CQContext.getINSTANCE().getOriginalOnt().getGCIs().size());
        AvarCQ q0;

        successfulRuns = 0;
        totalTime = 0;
        for (int i = 0; i < NUMBER_OF_RUNS; i++) {
            q0 = AvarCQ.getRandomAvarCQ(noVars, sigma);
            //QueryRewriter.runAvarCQ(axioms, q0, Thread.currentThread().getStackTrace()[1].getMethodName()+ontname + noVars + "-" + i);
        }
        if (successfulRuns > 0) {
            System.out.format("##### Percent successful: %.2f \n", (((double) successfulRuns) / NUMBER_OF_RUNS) * 100);
            System.out.format("##### (avar-" + ontname + noVars + ", %.5f) \n", (((double) totalTime) / successfulRuns / 1000));
        }
    }

    public static void runRandomRCQ(Set<OWLAxiom> axioms, String ontname, int noVars) throws OWLOntologyCreationException, CQException, Exception {

        Signature sigma = CQContext.getINSTANCE().getOriginalSignature();

        //System.out.println("Number of CIs in OrigOnt: " + CQContext.getINSTANCE().getOriginalOnt().getGCIs().size());
        RootedCQ q0;

        successfulRuns = 0;
        totalTime = 0;
        for (int i = 0; i < NUMBER_OF_RUNS; i++) {
            q0 = RootedCQ.getRandomRootedCQ(noVars, sigma);
            //QueryRewriter.runRootedCQ(axioms, q0, Thread.currentThread().getStackTrace()[1].getMethodName() + ontname + noVars + "-" + i);
        }
        if (successfulRuns > 0) {
            System.out.format("##### Percent successful: %.2f \n", (((double) successfulRuns) / NUMBER_OF_RUNS) * 100);
            System.out.format("##### (rcq-" + ontname + noVars + ", %.5f) \n", (((double) totalTime) / successfulRuns / 1000));
        }
    }

}
