/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.syntax;

import de.unibremen.informatik.tdki.grind2.context.CQContext;
import de.unibremen.informatik.tdki.grind2.cq.CQException;
import de.unibremen.informatik.tdki.grind2.cq.components.Variable;
import java.util.HashSet;
import java.util.Set;
import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLClassExpression;
import org.semanticweb.owlapi.model.OWLObjectSomeValuesFrom;

/**
 *
 * @author hansen
 */
public class Annotations {

    public static Set<OWLClassExpression> lhsAnnotation(Set<OWLClassExpression> oldLhsTlcs, Variable x) throws CQException {
        Set<OWLClassExpression> newLhsTlcs = new HashSet<>();
        for (OWLClassExpression concept : oldLhsTlcs) {
            if (concept instanceof OWLClass) {
                OWLClass cls = (OWLClass) concept;
                OWLClass newCls = CQContext.getINSTANCE().annotateCls(cls, x);
                newLhsTlcs.add(newCls);
            } else if (concept instanceof OWLObjectSomeValuesFrom) {
                OWLObjectSomeValuesFrom existRG = (OWLObjectSomeValuesFrom) concept;
                OWLClass newSpuriousCls = CQContext.getINSTANCE().annotateSpurious(existRG, x);
                newLhsTlcs.add(newSpuriousCls);
            } else {
                throw new CQException("[" + CQContext.class.getSimpleName() + "] Found " + concept + ", neither classs nor existential!");
            }
        }
        return newLhsTlcs;
    }

    public static Set<OWLClassExpression> rhsAnnotation(Set<OWLClassExpression> oldRhsTlcs, Variable x) throws CQException {
        Set<OWLClassExpression> newRhsTlcs = new HashSet<>();
        for (OWLClassExpression concept : oldRhsTlcs) {
            if (concept instanceof OWLClass) {
                OWLClass cls = (OWLClass) concept;
                OWLClass newCls = CQContext.getINSTANCE().annotateCls(cls, x);
                newRhsTlcs.add(newCls);
            } else if (concept instanceof OWLObjectSomeValuesFrom) {
                OWLObjectSomeValuesFrom existRG = (OWLObjectSomeValuesFrom) concept;
                OWLObjectSomeValuesFrom newExistRxG = CQContext.getINSTANCE().annotateExist(existRG, x);
                newRhsTlcs.add(newExistRxG);
            } else {
                throw new CQException("[" + CQContext.class.getSimpleName() + "] Found " + concept + ", neither classs nor existential!");
            }
        }
        return newRhsTlcs;
    }
    
}
